<template>
  <transition
    name="expand"
    @enter="enter"
    @after-enter="afterEnter"
    @leave="leave"
  >
    <slot />
  </transition>
</template>

<script>
  export default {
    props: {
      scrollIntoView: {
        type: Boolean,
        default: false
      }
    },
    methods: {
      enter(el) {
        const width = getComputedStyle(el).width;
        el.style.width = width;
        el.style.position = "absolute";
        el.style.visibility = "hidden";
        el.style.height = "auto";

        const height = getComputedStyle(el).height;

        el.style.width = null;
        el.style.position = null;
        el.style.visibility = null;
        el.style.height = 0;

        setTimeout(() => {
          el.style.height = height;
        });
      },

      afterEnter(el) {
        el.style.height = "auto";
        if (this.scrollIntoView) {
          el.scrollIntoView({ block: "start", behavior: 'smooth' });
        }
      },

      leave(el) {
        const height = getComputedStyle(el).height;
        el.style.height = height;

        setTimeout(() => {
          el.style.height = 0;
        })
      }
    }
  }
</script>

<style lang="scss" scoped>
.expand-enter-active,
.expand-leave-active {
  transition: height 0.2s ease-in-out;
  overflow: hidden;
}

.expand-enter,
.expand-leave-to {
  height: 0;
}
</style>